/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};

const addButton = () => {   
    const container = document.querySelector('#targetContainer'); 
    const componentLibraryPath = container.resolveUrl('../');       // resolve the versioned component library path
    Polymer.Base.importHref(componentLibraryPath + 'ti-widget-common/ti-widget-button.html', event => {
        const button = document.createElement('ti-widget-button');
        button.label = 'My Custom Button';
        button.raised = true;
        Polymer.dom(container).appendChild(button);
        button.addEventListener('click', ( () => {
            let counter = 0;
            return () => {alert(`Clicked ${++counter} times!`)};
        })() );
    }, error => {
        console.log(error);
    });
};


/*
*  Boilerplate code for working with components in the application gist
*/

var initComplete = false;
var templateObj;

// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
	templateObj.addEventListener('dom-change',function(){
	    if (initComplete) return;
	    this.async(function(){
    	    initComplete = true;
    	    console.log("Application template has been stamped.");
  	        
  	        addButton();
  	        templateObj.$.addBtn.addEventListener('click', addButton);
        },1);

	});
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded',init.bind(this))
}


